## ros-iron-robot-calibration 0.8.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(robot_calibration)

# Default to C99
if(NOT CMAKE_C_STANDARD)
  set(CMAKE_C_STANDARD 99)
endif()

# Default to C++14
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic)
endif()

find_package(orocos_kdl REQUIRED)
find_package(ament_cmake REQUIRED)
find_package(camera_calibration_parsers REQUIRED)
find_package(Ceres REQUIRED)
find_package(control_msgs REQUIRED)
find_package(cv_bridge REQUIRED)
find_package(geometry_msgs REQUIRED)
find_package(geometric_shapes REQUIRED)
find_package(kdl_parser REQUIRED)
find_package(moveit_msgs REQUIRED)
find_package(nav_msgs REQUIRED)
find_package(OpenCV REQUIRED)
find_package(pluginlib REQUIRED)
find_package(rclcpp REQUIRED)
find_package(rclcpp_action REQUIRED)
find_package(robot_calibration_msgs REQUIRED)
find_package(rosbag2_cpp REQUIRED)
find_package(sensor_msgs REQUIRED)
find_package(std_msgs REQUIRED)
find_package(tf2_geometry_msgs REQUIRED)
find_package(tf2_ros REQUIRED)
find_package(urdf REQUIRED)
find_package(visualization_msgs REQUIRED)
find_package(yaml-cpp REQUIRED)

include_directories(include
                    ${Boost_INCLUDE_DIRS}
                    ${CERES_INCLUDES}
                    ${EIGEN3_INCLUDE_DIRS}
                    ${orocos_kdl_INCLUDE_DIRS})
link_directories(${orocos_kdl_LIBRARY_DIRS}) # this is a hack, will eventually be unneeded once orocos-kdl is fixed

set(dependencies
  camera_calibration_parsers
  control_msgs
  cv_bridge
  geometry_msgs
  geometric_shapes
  kdl_parser
  moveit_msgs
  nav_msgs
  pluginlib
  rclcpp
  rclcpp_action
  robot_calibration_msgs
  rosbag2_cpp
  sensor_msgs
  tf2_geometry_msgs
  tf2_ros
  urdf
  visualization_msgs
)

add_library(robot_calibration SHARED
  src/base_calibration.cpp
  src/models.cpp
  src/optimization/ceres_optimizer.cpp
  src/optimization/export.cpp 
  src/optimization/offsets.cpp
  src/optimization/params.cpp
  src/util/capture_manager.cpp
  src/util/chain_manager.cpp
  src/util/poses_from_bag.cpp
  src/util/poses_from_yaml.cpp
  src/util/mesh_loader.cpp
)
target_link_libraries(robot_calibration
  ${Boost_LIBRARIES}
  ${CERES_LIBRARIES}
  ${tinyxml_LIBRARIES}
  ${orocos_kdl_LIBRARIES}
)
ament_target_dependencies(robot_calibration
  ${dependencies}
)

add_library(robot_calibration_feature_finders SHARED
  src/finders/checkerboard_finder.cpp
  src/finders/led_finder.cpp
  src/finders/plane_finder.cpp
  src/finders/robot_finder.cpp
  src/finders/scan_finder.cpp
)
target_link_libraries(robot_calibration_feature_finders
  robot_calibration
  ${Boost_LIBRARIES}
  ${tinyxml_LIBRARIES}
  ${orocos_kdl_LIBRARIES}
  ${OpenCV_LIBS}
)
ament_target_dependencies(robot_calibration_feature_finders
  ${dependencies}
)

add_executable(calibrate src/nodes/calibrate.cpp)
target_link_libraries(calibrate
  robot_calibration
  ${Boost_LIBRARIES}
  ${CERES_LIBRARIES}
  ${tinyxml_LIBRARIES}
  ${orocos_kdl_LIBRARIES}
  ${OpenCV_LIBS}
)
ament_target_dependencies(calibrate
  ${dependencies}
)

add_executable(base_calibration_node src/nodes/base_calibration.cpp)
target_link_libraries(base_calibration_node
  robot_calibration
  ${Boost_LIBRARIES}
)

add_executable(magnetometer_calibration src/nodes/magnetometer_calibration.cpp)
target_link_libraries(magnetometer_calibration
  ${CERES_LIBRARIES}
)
ament_target_dependencies(magnetometer_calibration
  ${dependencies}
)

add_executable(to_rpy src/nodes/to_rpy.cpp)
target_link_libraries(to_rpy
  robot_calibration
  ${Boost_LIBRARIES}
  ${orocos_kdl_LIBRARIES}
)

add_executable(viz src/nodes/viz.cpp)
target_link_libraries(viz
  robot_calibration
  ${Boost_LIBRARIES}
  ${orocos_kdl_LIBRARIES}
)

add_executable(viz_mesh src/nodes/viz_mesh.cpp)
target_link_libraries(viz_mesh
  robot_calibration
  ${Boost_LIBRARIES}
  ${orocos_kdl_LIBRARIES}
)

if(BUILD_TESTING)
  add_subdirectory(test)
endif()

install(DIRECTORY include/ DESTINATION include)

install(TARGETS
  base_calibration_node
  calibrate
  magnetometer_calibration
  robot_calibration
  robot_calibration_feature_finders
  to_rpy
  viz
  viz_mesh
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION lib/robot_calibration
)

pluginlib_export_plugin_description_file(robot_calibration robot_calibration.xml)

ament_export_include_directories(include)
ament_export_libraries(robot_calibration robot_calibration_feature_finders)
ament_export_dependencies(${dependencies})
ament_package()

=== test/CMakeLists.txt ===
find_package(ament_cmake_gtest REQUIRED)

ament_add_gtest(optimization_offsets_tests optimization_offsets_tests.cpp)
target_link_libraries(optimization_offsets_tests robot_calibration
                                                 ${orocos_kdl_LIBRARIES})
ament_target_dependencies(optimization_offsets_tests ${dependencies})

ament_add_gtest(chain_model_tests chain_model_tests.cpp)
target_link_libraries(chain_model_tests robot_calibration
                                        ${CERES_LIBRARIES}
                                        ${orocos_kdl_LIBRARIES})
ament_target_dependencies(chain_model_tests ${dependencies})

ament_add_gtest(poses_from_yaml_tests poses_from_yaml_tests.cpp
                WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}")
target_link_libraries(poses_from_yaml_tests robot_calibration)
ament_target_dependencies(poses_from_yaml_tests ${dependencies})

ament_add_gtest(rotation_tests rotation_tests.cpp)
target_link_libraries(rotation_tests robot_calibration
                                     ${CERES_LIBRARIES}
                                     ${orocos_kdl_LIBRARIES})
ament_target_dependencies(rotation_tests ${dependencies})

ament_add_gtest_executable(camera_info_tests camera_info_tests.cpp)
target_link_libraries(camera_info_tests robot_calibration
                                        ${GTEST_LIBRARIES})
ament_target_dependencies(camera_info_tests ${dependencies})

ament_add_gtest_executable(chain_manager_tests chain_manager_tests.cpp)
target_link_libraries(chain_manager_tests robot_calibration
                                          ${GTEST_LIBRARIES})
ament_target_dependencies(chain_manager_tests ${dependencies})

ament_add_gtest_executable(error_block_tests error_block_tests.cpp)
target_link_libraries(error_block_tests robot_calibration
                                        ${CERES_LIBRARIES}
                                        ${GTEST_LIBRARIES}
                                        ${orocos_kdl_LIBRARIES})
ament_target_dependencies(error_block_tests ${dependencies})

ament_add_gtest_executable(error_block_tests2 error_block_tests2.cpp)
target_link_libraries(error_block_tests2 robot_calibration
                                         ${CERES_LIBRARIES}
                                         ${GTEST_LIBRARIES}
                                         ${orocos_kdl_LIBRARIES})
ament_target_dependencies(error_block_tests2 ${dependencies})

ament_add_gtest_executable(feature_finder_loader_tests feature_finder_loader_tests.cpp)
target_link_libraries(feature_finder_loader_tests robot_calibration ${GTEST_LIBRARIES})
ament_target_dependencies(feature_finder_loader_tests ${dependencies})

ament_add_gtest_executable(optimization_param_tests optimization_param_tests.cpp)
target_link_libraries(optimization_param_tests robot_calibration ${GTEST_LIBRARIES})
ament_target_dependencies(optimization_param_tests ${dependencies})

ament_add_test(camera_info_tests_launch
  GENERATE_RESULT_FOR_RETURN_CODE_ZERO
  COMMAND "${CMAKE_CURRENT_SOURCE_DIR}/camera_info_tests_launch.py"
  WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
  ENV
    TEST_EXECUTABLE=$<TARGET_FILE:camera_info_tests>
    INFO_PUBLISHER=${CMAKE_CURRENT_SOURCE_DIR}/camera_info_publisher.py
)

ament_add_test(chain_manager_tests_launch
  GENERATE_RESULT_FOR_RETURN_CODE_ZERO
  COMMAND "${CMAKE_CURRENT_SOURCE_DIR}/chain_manager_tests_launch.py"
  WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
  ENV
    TEST_EXECUTABLE=$<TARGET_FILE:chain_manager_tests>
    CONFIG_DIR=${CMAKE_CURRENT_SOURCE_DIR}
)

ament_add_test(error_block_tests_launch
  GENERATE_RESULT_FOR_RETURN_CODE_ZERO
  COMMAND "${CMAKE_CURRENT_SOURCE_DIR}/error_block_tests_launch.py"
  WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
  ENV
    TEST_EXECUTABLE=$<TARGET_FILE:error_block_tests>
    CONFIG_DIR=${CMAKE_CURRENT_SOURCE_DIR}
)

ament_add_test(error_block_tests2_launch
  GENERATE_RESULT_FOR_RETURN_CODE_ZERO
  COMMAND "${CMAKE_CURRENT_SOURCE_DIR}/error_block_tests2_launch.py"
  WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
  ENV
    TEST_EXECUTABLE=$<TARGET_FILE:error_block_tests2>
    CONFIG_DIR=${CMAKE_CURRENT_SOURCE_DIR}
)

ament_add_test(feature_finder_loader_test_launch
  GENERATE_RESULT_FOR_RETURN_CODE_ZERO
  COMMAND "${CMAKE_CURRENT_SOURCE_DIR}/feature_finder_loader_tests_launch.py"
  WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
  ENV
    TEST_EXECUTABLE=$<TARGET_FILE:feature_finder_loader_tests>
    INFO_PUBLISHER=${CMAKE_CURRENT_SOURCE_DIR}/camera_info_publisher.py
    CONFIG_DIR=${CMAKE_CURRENT_SOURCE_DIR}
)

ament_add_test(optimization_param_tests_launch
  GENERATE_RESULT_FOR_RETURN_CODE_ZERO
  COMMAND "${CMAKE_CURRENT_SOURCE_DIR}/optimization_param_tests_launch.py"
  WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
  ENV
    TEST_EXECUTABLE=$<TARGET_FILE:optimization_param_tests>
    CONFIG_DIR=${CMAKE_CURRENT_SOURCE_DIR}
)

=== debian/changelog ===
ros-iron-robot-calibration (0.8.0-3jammy) jammy; urgency=high

  * various fixes from on-robot testing (#136 <https://github.com/mikeferguson/robot_calibration/issues/136>)
    * fix topic names in load_bag
    * update DepthCameraInfoManager to read proper parameters from camera node
    * fix path/names for pluginlib portability
    * better debug messages when capturing
    * better debug messages from ChainManager
  * add yaml option for storing capture poses (#135 <https://github.com/mikeferguson/robot_calibration/issues/135>)
    * load calibration poses from YAML
    * add test for YAML loading
    * add porting script to get ROS1 bagfiles converted to YAML file
  * remove tinyxml from CMake (#134 <https://github.com/mikeferguson/robot_calibration/issues/134>)
    this is a left over from the XML RPC days
  * initial ROS2 port of robot_calibration (#133 <https://github.com/mikeferguson/robot_calibration/issues/133>)
    * port finders to ROS2
    * port optimization to ROS2
    * port tests to ROS
    * reorganize file structure for better clarity around header file usage
    * update readme
    Major changes for ROS2:
    * In ROS1, many of the parameters were an array of complex structures - this does
    not work well with ROS2 and the declaration of parameters. Instead, we use an array
    of structure names, and then we can declare namespaced parameters for each of
    the structures.
    * chain model has been renamed to chain3d
  * port robot_calibration_msgs to ROS2, update CI (#131 <https://github.com/mikeferguson/robot_calibration/issues/131>)
  * enhance alignment (#130 <https://github.com/mikeferguson/robot_calibration/issues/130>)
    * handle NANs in laser data
    * add r2_tolerance
    * add spinOnce so that we can run single threaded
    * exit loop if shutting down
  * fix regression in manual calibration (#129 <https://github.com/mikeferguson/robot_calibration/issues/129>)
  * fix warnings reported on ros.org buildfarm (#128 <https://github.com/mikeferguson/robot_calibration/issues/128>)
  * improve base calibration alignment (#127 <https://github.com/mikeferguson/robot_calibration/issues/127>)
    * add feature to align to arbitrary angle
    * parameterize things, including verbose
  * refactor base_calibration into separate class (#126 <https://github.com/mikeferguson/robot_calibration/issues/126>)
  * major refactor into re-usable components (#125 <https://github.com/mikeferguson/robot_calibration/issues/125>)
    * add getPosesFromBag function
    * add captureManager to clean up code and improve re-usability
    * split out exportResults as a function
    * for all models, renamed name() to getName(), added getType() function
    * add getCameraNames() function to optimizer, so that we can:
    * output camera calibrations for ALL cameras
  * Contributors: Michael Ferguson

 -- Michael Ferguson <mike@vanadiumlabs.com>  Fri, 24 Jun 2022 16:00:00 -0000

ros-iron-robot-calibration (0.7.0-3jammy) jammy; urgency=high

  * filter planes by closeness to desired normal (#124 <https://github.com/mikeferguson/robot_calibration/issues/124>)
  * add finder for laser scan data (#123 <https://github.com/mikeferguson/robot_calibration/issues/123>)
    best way to use this right now is to create point laser scanner at a
    wall, create a plane from the laser scan, and align it with a plane
    that has been seen by a camera
  * sample observation more evenly (#122 <https://github.com/mikeferguson/robot_calibration/issues/122>)
    the plane finder previously took points that were equally distributed by
    point cloud index - however this doesn't actually always represent a
    point cloud that is geometry well distributed. change the sampling so
    that we make one or more passes through the cloud sampling points that
    are at least a minimum distance away from the already sampled points
  * refactor plane finder (#121 <https://github.com/mikeferguson/robot_calibration/issues/121>)
    * use new eigen_geometry.h functions
    * use ransac to find the best plane
  * refactor and improve plane_to_plane cost function (#120 <https://github.com/mikeferguson/robot_calibration/issues/120>)
    * use Eigen rather than OpenCV
    * break plane parameter functions into separate header for reuse
    * make final residual distance between planes
    * make plane parameters always in same direction
  * make it easier to exit out of calibration (#119 <https://github.com/mikeferguson/robot_calibration/issues/119>)
  * parameterize max_num_iterations (#118 <https://github.com/mikeferguson/robot_calibration/issues/118>)
  * add chain3dToMesh calibration (#116 <https://github.com/mikeferguson/robot_calibration/issues/116>)
    * add cost function
    * add mesh loader utilities
    * add node to visualize meshes load
  * allow using the same camera model with different finders (#112 <https://github.com/mikeferguson/robot_calibration/issues/112>)
    the use case here is that a single camera is used in multiple
    finders. When that happens we want the same parameters to
    be used when calibrating the camera intrinsics, but we
    need a different camera name to differentiate which
    observation should be associated with which error block
    (this is especially true for the upcoming robot/plane
    finder)
  * add robot finder (#111 <https://github.com/mikeferguson/robot_calibration/issues/111>)
    The robot finder can be used to find the base of the robot and the floor at the same time
  * increase marker size (#117 <https://github.com/mikeferguson/robot_calibration/issues/117>)
  * minor improvements and fixes for viz node (#110 <https://github.com/mikeferguson/robot_calibration/issues/110>)
    * move publishers earlier and make latching
    * don't crash if no points in observation after projecting
  * refactor and improve plane finder (#109 <https://github.com/mikeferguson/robot_calibration/issues/109>)
    * break up the find() function so that it is more re-usable


=== debian/control ===
Source: ros-iron-robot-calibration
Section: misc
Priority: optional
Maintainer: Michael Ferguson <mike@vanadiumlabs.com>
Build-Depends: debhelper (>= 9.0.0), libboost-filesystem-dev, libceres-dev, libeigen3-dev, libgflags-dev, liborocos-kdl-dev, libprotobuf-dev, libprotoc-dev, libsuitesparse-dev, libyaml-cpp-dev, protobuf-compiler, ros-iron-ament-cmake, ros-iron-ament-cmake-gtest <!nocheck>, ros-iron-camera-calibration-parsers, ros-iron-control-msgs, ros-iron-cv-bridge, ros-iron-geometric-shapes, ros-iron-geometry-msgs, ros-iron-kdl-parser, ros-iron-launch <!nocheck>, ros-iron-launch-ros <!nocheck>, ros-iron-launch-testing <!nocheck>, ros-iron-moveit-msgs, ros-iron-nav-msgs, ros-iron-pluginlib, ros-iron-rclcpp, ros-iron-rclcpp-action, ros-iron-robot-calibration-msgs, ros-iron-rosbag2-cpp, ros-iron-sensor-msgs, ros-iron-std-msgs, ros-iron-tf2-geometry-msgs, ros-iron-tf2-ros, ros-iron-visualization-msgs, ros-iron-ros-workspace
Homepage: http://ros.org/wiki/robot_calibration
Standards-Version: 3.9.2

Package: ros-iron-robot-calibration
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libceres-dev, libgflags-dev, liborocos-kdl-dev, libprotobuf-dev, libprotoc-dev, libsuitesparse-dev, libyaml-cpp-dev, protobuf-compiler, ros-iron-camera-calibration-parsers, ros-iron-control-msgs, ros-iron-cv-bridge, ros-iron-geometric-shapes, ros-iron-geometry-msgs, ros-iron-kdl-parser, ros-iron-moveit-msgs, ros-iron-nav-msgs, ros-iron-pluginlib, ros-iron-rclcpp, ros-iron-rclcpp-action, ros-iron-robot-calibration-msgs, ros-iron-rosbag2-cpp, ros-iron-sensor-msgs, ros-iron-std-msgs, ros-iron-tf2-geometry-msgs, ros-iron-tf2-ros, ros-iron-visualization-msgs, ros-iron-ros-workspace
Description: Calibrate a Robot

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/iron/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/iron" \
		-DAMENT_PREFIX_PATH="/opt/ros/iron" \
		-DCMAKE_PREFIX_PATH="/opt/ros/iron" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-iron-robot-calibration//opt/ros/iron/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_auto_install
